#define NUM_LOOPS 10

enum
{
	NO_AXIS,
	X_AXIS,
	Y_AXIS,
	MINUS_X_AXIS,
	MINUS_Y_AXIS,
	X2_AXIS,
	Y2_AXIS,
	MINUS_X2_AXIS,
	MINUS_Y2_AXIS
};

enum
{
	NO_RECORD,
	L_DUB,
	R_DUB,
	L_RECORD,
	R_RECORD
};

enum
{
	NO_FX,
	YES_FX
};


#ifdef INIT_GLOBALS
int mouse_spinner_value[8] = {0, 0, 0, 0, 0, 0, 0, 0};
int mouse_spinner_axis[8] = {NO_AXIS, NO_AXIS, NO_AXIS, 
	NO_AXIS, NO_AXIS, NO_AXIS, NO_AXIS, NO_AXIS};

// one int[6] for each loop, points to an array of //
// speed, start, end, phase, vol, pan            ///
// each is a number between 0 and 999.            //
int scr1_parms[6][NUM_LOOPS];
// measures for each loop before repeat ////////////
int scr1_measures[NUM_LOOPS]; // value is 2 (n-4) //
// recording mode, from the enum above ////////////
int scr1_record[NUM_LOOPS];
// fx on or off //
int scr1_fx[NUM_LOOPS];
// each of these numbers can be linked to a mouse //
// spinner				          //
int scr1_parmlink[6][NUM_LOOPS];
// PCM wave data and controlling mutex functions  //
unsigned int loopLength[NUM_LOOPS];
char * loopData[NUM_LOOPS];
// current position that data is reading out from //
unsigned int loopPos[NUM_LOOPS];
// last phase offset from run_looper - allows smooth //
// scratching with the PHASE control	///////////////
int loopLastPhaseOffset[NUM_LOOPS];
// last "phased" cursor - so you can see your scratching //
// used in draw_oscillograph in gui1.c ////////////////////
// written by run_looper //////////////////////////////////
int loopPhasedPos[NUM_LOOPS];

pthread_mutex_t loopMutex[NUM_LOOPS];

void init_l_parms() 
{
	int i, j;
	for (i=0;i<NUM_LOOPS;i++)
	{
		pthread_mutex_init(&loopMutex[i], NULL);
		loopData[i]=NULL;
		loopLength[i]=0;
		loopPos[i]=0;
		loopLastPhaseOffset[i]=0;
		loopPhasedPos[i]=0;
		scr1_measures[i] = 4;
		scr1_record[i]=NO_RECORD;
		scr1_fx[i]=NO_FX;
		scr1_parms[0][i]=100; // SPEED
		scr1_parms[1][i]=0;   // START
		scr1_parms[2][i]=999; // END
		scr1_parms[3][i]=0;   // PHASE
		scr1_parms[4][i]=500; // VOL
		scr1_parms[5][i]=500; // PAN
		for (j=0;j<6;j++) scr1_parmlink[j][i]=-1;	
	}
}

#else
extern int mouse_spinner_value[];
extern int mouse_spinner_axis[];
extern int scr1_parms[6][NUM_LOOPS];
extern int scr1_parmlink[6][NUM_LOOPS];
extern char * loopData[];
extern unsigned int loopLength[];
extern unsigned int loopPos[];
extern int loopLastPhaseOffset[];
extern int loopPhasedPos[];
extern int scr1_measures[];
extern int scr1_record[];
extern int scr1_fx[];
#endif

void lockLoop(int L);
void unlockLoop(int L);
int isLoopLocked(int L);
void destroyLoopMutexes();
void deleteLoop(int L);
int isLoopFull(int L);

extern char llError[];
int loadLoop(int L, char * fileName);
