/////////////////////////////////////////////////////////////////////////////////////////////////////////
//	functions for effect stuff - the actual good shitty shit!  don't kill any elephants for their ///
//	teeth! /////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "cardfeed.h"
#include "loopdata.h"
#include "gui.h"
#include "audio.h"
#include "fxdata.h"
#include "pump.h"

void Eff_Distortion(int Loop, int Col)
{
	effect_stat * es;
	int nSamps;
	int Dist, Tone, Lvl, Pre;
	int i; int tmp;
	int Last;
	es = (effect_stat *) &fx_layout[Loop][Col];
	nSamps = buf_size/4;
	Dist = es->parms[0];
	Tone = es->parms[1];
	Tone = (Tone > 900) ? 900 : Tone;
	Lvl = es->parms[2];
	// easing into it with this simple effect //
	// store last value of output... make room for it //
	if (es->extra == NULL) {es->extra = malloc(sizeof(int)); * ( (int *) es->extra) = 0;}
	Last = * ( (int *) es->extra);
	for (i=0;i<nSamps;i++)
	{
		tmp = (es->in_buf[0])[i];
		tmp *= Dist; 
		tmp /= 20; // max gain is now 50
		tmp = (tmp < -32767) ? -32767 : (tmp > 32767) ? 32767 : tmp;
		// do Tone control
		tmp = (1000 - Tone) * tmp + (Tone * Last / 10);
		tmp /= 100;
		Pre = tmp;
		// do Lvl adjustment
		tmp *= Lvl; tmp /= 10000;
		tmp = (tmp < -32767) ? -32767 : (tmp > 32767) ? 32767 : tmp;
		(es->out_buf[0])[i]=tmp;
		Last = Pre;
	}
	* ( (int *) es->extra) = Last;
}

int OD_Lookup[32768];

static int is_OD_Table = 0;

void make_OD_Table()
{
	int i;
	float scale = 3.14159265f / 65536.0f;
	if (is_OD_Table) return;
	is_OD_Table = 1;
	for (i=0; i<32768; i++)
	{
		OD_Lookup[i] = (int) 32768.0f * sin
				( (float) i * scale);
	}
	
}


void Eff_Overdrive (int Loop, int Col)
{
	effect_stat * es;
	int nSamps;
	int Dist, Lvl;
	int i, tmp, total; 
	es = (effect_stat *) &fx_layout[Loop][Col];
	nSamps = buf_size/4;
	Dist = es->parms[0] + 16;
	Lvl = es->parms[1] + 24;
	//make_OD_Table();
	for (i=0;i<nSamps;i++)
	{
		tmp = (es->in_buf[0])[i];
		tmp *= Dist; tmp /= 16;
		tmp = (tmp > 32767) ? 32767 : (tmp < -32767) ? -32767 : tmp;
		if (tmp >= 0)
			total = OD_Lookup[tmp];
		else
			total = - OD_Lookup[-tmp];
		total *= Lvl; total /= 1024;
		(es->out_buf[0])[i] = total;
	}
	
}


void Eff_Modulator(int Loop, int Col)
{
	effect_stat * es;
	int nSamps;
	int Bias, Lvl;
	int i; int tmp;
	es = (effect_stat *) &fx_layout[Loop][Col];
	nSamps = buf_size/4;
	Bias = es->parms[0]; Lvl = es->parms[1];
	// multiply in_buf[0] by in_buf[1] + constant //
	for (i=0;i<nSamps;i++)
	{
		tmp = (es->in_buf[1])[i]; // get modulation signal
		tmp += Bias*32;		  // bias modulation signal
		tmp /= 128;
		tmp *= (es->in_buf[0])[i]; // multiply by carrier
		tmp /= 256;
		tmp *= Lvl; tmp /= 512;	   // adjust level
		tmp = (tmp < -32767) ? -32767 : (tmp > 32767) ? 32767 : tmp;
		(es->out_buf[0])[i]=tmp;
		
	}
}

void Eff_Equalization(int Loop, int Col)
{
	/* many many thanks to paul.kellett@maxim.abel.co.uk
		http://www.maxim.abel.co.uk
	   for the resonant low pass filter presented here */
	
	effect_stat * es;
	int nSamps;
	int Mode, Freq, Res;
	int F, Q, FB;
	int Buf0, Buf1, tmp;
	int i; 
	es = (effect_stat *) &fx_layout[Loop][Col];
	nSamps = buf_size/4;
	Mode = es->parms[0]; Freq = es->parms[1]; Res = es->parms[2];
	// retrieve Buf0, Buf1 from extra data area//
	if (es->extra == NULL) 
	{
		es->extra = malloc(2* sizeof(int)); 
		memset(es->extra, 0, 2*sizeof(int));
	}
	Buf0 = ((int *) es->extra)[0];
	Buf1 = ((int *) es->extra)[1];
	// need to set up F, Q as values between 0 and 1 //
	// as they are integer, will be scaled 0 to 1024 //
	// just let them be for now.... as 0 to 1000 //////
	F = Freq + 1; Q = Res + 1; 
	// and now need to set up FB = Q + Q/(1.0 - F); ///
	// use 1024 integer scaling ///////////////////////
	FB = Q + (Q * 1024 ) / (1024 - F);
	// do the filtering //

	for (i=0;i<nSamps;i++)
	{
		Buf0 += F * ( (es->in_buf[0])[i] - Buf0 + ( FB * (Buf0 - Buf1) / 1024) ) / 1024;
		Buf1 += F * ( Buf0 - Buf1 ) / 1024;
		switch (Mode)
		{
			case 0: default:
				tmp = Buf1; break;
			case 1: 
				tmp = (es->in_buf[0])[i] - Buf1; break;
		};
		
		tmp = (tmp < -32767) ? -32767 : (tmp > 32767) ? 32767 : tmp;
		(es->out_buf[0])[i] = tmp;
	}
	// store Buf0, Buf1
	((int*) es->extra)[0] = Buf0;
	((int*) es->extra)[1] = Buf1;
}

void Eff_Split(int Loop, int Col)
{
	effect_stat * es;
	int nSamps;
	int i; 
	es = (effect_stat *) &fx_layout[Loop][Col];
	nSamps = buf_size/4;
	for (i=0;i<nSamps;i++)
	{
		(es->out_buf[0])[i] = (es->in_buf[0])[i];
		(es->out_buf[1])[i] = (es->in_buf[0])[i];
			
	}
		
}

void Eff_Mix(int Loop, int Col)
{
	effect_stat * es;
	int nSamps;
	int i; int tmp, total;
	int v1, v2;
	es = (effect_stat *) &fx_layout[Loop][Col];
	nSamps = buf_size/4;
	v1 = es->parms[0]; v2 = es->parms[1];
	for (i=0;i<nSamps;i++)
	{
		tmp = ((es->in_buf[0])[i] * v1 )/ 512;
		total = ((es->in_buf[1])[i] * v2)/ 512;
		total += tmp;
		total = (total < -32767) ? -32767 :
			(total > 32767) ? 32767 : total;
		(es->out_buf[0])[i] = total;
	}
}


typedef struct _Echo_Buf
{
	int cursor;
	int data[65536];
} Echo_Buf;



void Eff_Echo (int Loop, int Col)
{
	effect_stat * es;
	int nSamps;
	int i; 
	int outmix, rgnmix;
	int Delay, Wet, Dry, Regen, delpos, putpos;
	Echo_Buf * eb;
	es = (effect_stat *) &fx_layout[Loop][Col];
	nSamps = buf_size/4;
	if (es->extra == NULL) 
	{
		es->extra = calloc(1, sizeof(Echo_Buf)); 
	}
	eb = (Echo_Buf *) es->extra;
	Delay = es->parms[2] * 44;
	Wet = es->parms[0]; Dry = es->parms[1]; 
	Regen = es->parms[3];
	putpos = eb->cursor;
	delpos = eb->cursor - Delay - 1;
	while (delpos < 0) delpos += 65536;
	for (i=0;i<nSamps;i++)
	{
		outmix = (eb->data[delpos]*Wet)/1024;
		outmix += ((es->in_buf[0])[i]*Dry)/1024;
		outmix = (outmix > 32767) ? 32767 : 
			(outmix < -32767) ? -32767 : outmix;
		
		rgnmix = (eb->data[delpos]*Regen)/1024;
		rgnmix += (es->in_buf[0])[i];
		rgnmix = (rgnmix > 32767) ? 32767 :
			(rgnmix < -32767) ? -32767 : rgnmix;
		
		delpos++; delpos &= 65535;
		
		eb->data[putpos+i]  = rgnmix;
		(es->out_buf[0])[i] = outmix;
	}
	eb->cursor = (putpos+nSamps)&65535;
}

typedef struct _Chorus_Buf
{
	int cursor;
	int theta;
	int data[65536];
} Chorus_Buf;

typedef struct _Sin_Table
{
	int S[65536];
} A_Sin_Table;

static A_Sin_Table Sin_Table;
static int is_Sin_Table = 0;
static void make_Sin_Table()
{
	int i;
	float angle;
	float angleinc;
	if (is_Sin_Table) return;
	angle = 0.0f;
	angleinc = 6.2831853072f;
	angleinc /= 65536.0f;
	for (i=0;i<65536;i++)
	{
		Sin_Table.S[i] = (int) ( (1.0f+sin(angle)) * 1024.0f);
		angle += angleinc;
	}
	is_Sin_Table = 1;
}


void Eff_Chorus (int Loop, int Col)
{
	effect_stat * es;
	int nSamps;
	int i; 
	int outmix, rgnmix;
	int Delay, Wet, Dry, Regen, Speed, Depth, theta, delpos, putpos;
	Chorus_Buf * eb;
	es = (effect_stat *) &fx_layout[Loop][Col];
	nSamps = buf_size/4;
	if (es->extra == NULL) 
	{
		es->extra = calloc(1, sizeof(Chorus_Buf));
		if (es->extra == NULL) return;
	}
	//make_Sin_Table();
	eb = (Chorus_Buf *) es->extra;
	//Delay = es->parms[2] * 44;
	Speed = es->parms[1]; Depth = es->parms[2];
	Wet = es->parms[0]; Dry = 1000-Wet; 
	Regen = es->parms[3];
	theta = eb->theta;
	theta *= 16;
	
	Delay = Sin_Table.S[(theta / 16) & 65535];
	Delay *= Depth; Delay /= 4096;
	
	putpos = eb->cursor;
	delpos = eb->cursor - Delay - 1;
	while (delpos < 0) delpos += 65536;
	for (i=0;i<nSamps;i++)
	{
		outmix = (eb->data[delpos]*Wet)/1024;
		outmix += ((es->in_buf[0])[i]*Dry)/1024;
		outmix = (outmix > 32767) ? 32767 : 
			(outmix < -32767) ? -32767 : outmix;
		
		rgnmix = (eb->data[delpos]*Regen)/1024;
		rgnmix += (es->in_buf[0])[i];
		rgnmix = (rgnmix > 32767) ? 32767 :
			(rgnmix < -32767) ? -32767 : rgnmix;
		
		//delpos++; delpos &= 65535;
		
		eb->data[putpos]  = rgnmix;
		(es->out_buf[0])[i] = outmix;
		putpos++; putpos &= 65535;
		
		theta += Speed;
		Delay = Sin_Table.S[(theta / 16) & 65535];
		Delay *= Depth; Delay /= 1024;
		
		delpos = putpos - Delay - 1;
		while (delpos < 0) delpos += 65536;
		delpos &= 65535;
	
	}
	eb->cursor = putpos;
	eb->theta = (theta/16)&65535;
}

// limit to 1/10th second on buffer storage //
#define OB_SIZE 16384

typedef struct _Octave_Buf
{
	int zerox;
	int last;
	int cursor;
	int Buf0;
	int Buf1;
	int data[OB_SIZE];
} Octave_Buf;


void Eff_Octave (int Loop, int Col)
{
	effect_stat * es;
	int nSamps;
	int i, Filtered, Buf0, Buf1, F, Mix, Out; 
	int do_zerox;
	Octave_Buf * ob;
	es = (effect_stat *) &fx_layout[Loop][Col];
	nSamps = buf_size/4;
	if (es->extra == NULL) 
	{
		es->extra = calloc(1, sizeof(Octave_Buf)); 
		ob = (Octave_Buf *) es->extra;
		ob->zerox = ob->last = ob->cursor = 0;
	}
	ob = (Octave_Buf *) es->extra;
	Buf0 = ob->Buf0;
	Buf1 = ob->Buf1;
	Mix = es->parms[0];
	F = 25;
	for (i=0;i<nSamps;i++)
	{
		// do lo-pass filtering
		Buf0 += F * ( (es->in_buf[0])[i] - Buf0) / 1024;
		Buf1 += F * ( Buf0 - Buf1 ) / 1024;
		Filtered = Buf1;
		// detect upward-moving zero crossings
		do_zerox = 0;
		if (Filtered >= 0)
			if (ob->last < 0)
				do_zerox = 1;
		ob->last = Filtered;
		
		// add data to ob->data[] and play it back at halfspeed
		// if buffer full, reset it now!
		ob->data[ob->cursor] = Filtered;
		Out = ( (1024 - Mix) * (es->in_buf[0])[i]) / 1024 + (Mix * ob->data[ob->cursor/2])/1024;
		Out = (Out > 32767) ? 32767 : (Out < -32767) ? -32767 : Out;
		(es->out_buf[0])[i] = Out;
		ob->cursor++;
		if (ob->cursor >= OB_SIZE)
		{
			ob->zerox = 0;
			ob->cursor = 0;
		}
		// also do a reset after 2 upward-zero crossings
		if (do_zerox) ob->zerox++;
		if (ob->zerox == 4)
		{
			ob->zerox = 0;
			ob->cursor = 0;
		}
		
	}
	ob->Buf0 = Buf0;
	ob->Buf1 = Buf1;
	
}

void init_Eff_Internals()
{
	make_Sin_Table();
	make_OD_Table();	
}
